diff --git a/src/backend/commands/typecmds.c b/src/backend/commands/typecmds.c
index e5fa0578889..ad2acdb575c 100644
--- a/src/backend/commands/typecmds.c
+++ b/src/backend/commands/typecmds.c
@@ -2623,9 +2623,9 @@ AlterDomainDefault(List *names, Node *defaultRaw)
 	Relation	rel;
 	char	   *defaultValue;
 	Node	   *defaultExpr = NULL; /* NULL if no default specified */
-	Datum		new_record[Natts_pg_type] = {0};
-	bool		new_record_nulls[Natts_pg_type] = {0};
-	bool		new_record_repl[Natts_pg_type] = {0};
+	Datum		values[Natts_pg_type] = {0};
+	bool		nulls[Natts_pg_type] = {false};
+	Bitmapset  *updated = NULL;
 	HeapTuple	newtuple;
 	Form_pg_type typTup;
 	ObjectAddress address;
@@ -2673,10 +2673,8 @@ AlterDomainDefault(List *names, Node *defaultRaw)
 		{
 			/* Default is NULL, drop it */
 			defaultExpr = NULL;
-			new_record_nulls[Anum_pg_type_typdefaultbin - 1] = true;
-			new_record_repl[Anum_pg_type_typdefaultbin - 1] = true;
-			new_record_nulls[Anum_pg_type_typdefault - 1] = true;
-			new_record_repl[Anum_pg_type_typdefault - 1] = true;
+			HeapTupleUpdateValueNull(pg_type, typdefaultbin, values, nulls, updated);
+			HeapTupleUpdateValueNull(pg_type, typdefault, values, nulls, updated);
 		}
 		else
 		{
@@ -2691,27 +2689,21 @@ AlterDomainDefault(List *names, Node *defaultRaw)
 			/*
 			 * Form an updated tuple with the new default and write it back.
 			 */
-			new_record[Anum_pg_type_typdefaultbin - 1] = CStringGetTextDatum(nodeToString(defaultExpr));
-
-			new_record_repl[Anum_pg_type_typdefaultbin - 1] = true;
-			new_record[Anum_pg_type_typdefault - 1] = CStringGetTextDatum(defaultValue);
-			new_record_repl[Anum_pg_type_typdefault - 1] = true;
+			HeapTupleUpdateValue(pg_type, typdefaultbin, CStringGetTextDatum(nodeToString(defaultExpr)), values, nulls, updated);
+			HeapTupleUpdateValue(pg_type, typdefault, CStringGetTextDatum(defaultValue), values, nulls, updated);
 		}
 	}
 	else
 	{
 		/* ALTER ... DROP DEFAULT */
-		new_record_nulls[Anum_pg_type_typdefaultbin - 1] = true;
-		new_record_repl[Anum_pg_type_typdefaultbin - 1] = true;
-		new_record_nulls[Anum_pg_type_typdefault - 1] = true;
-		new_record_repl[Anum_pg_type_typdefault - 1] = true;
+		HeapTupleUpdateValueNull(pg_type, typdefaultbin, values, nulls, updated);
+		HeapTupleUpdateValueNull(pg_type, typdefault, values, nulls, updated);
 	}
 
-	newtuple = heap_modify_tuple(tup, RelationGetDescr(rel),
-								 new_record, new_record_nulls,
-								 new_record_repl);
+	newtuple = heap_update_tuple(tup, RelationGetDescr(rel),
+								 values, nulls, updated);
 
-	CatalogTupleUpdate(rel, &tup->t_self, newtuple);
+	CatalogTupleUpdate(rel, &tup->t_self, newtuple, updated, NULL);
 
 	/* Rebuild dependencies */
 	GenerateTypeDependencies(newtuple,
@@ -2731,6 +2723,7 @@ AlterDomainDefault(List *names, Node *defaultRaw)
 	/* Clean up */
 	table_close(rel, RowExclusiveLock);
 	heap_freetuple(newtuple);
+	bms_free(updated);
 
 	return address;
 }
@@ -2751,6 +2744,7 @@ AlterDomainNotNull(List *names, bool notNull)
 	HeapTuple	tup;
 	Form_pg_type typTup;
 	ObjectAddress address = InvalidObjectAddress;
+	Bitmapset  *updated = NULL;
 
 	/* Make a TypeName so we can use standard type lookup machinery */
 	typename = makeTypeNameFromNameList(names);
@@ -2806,9 +2800,9 @@ AlterDomainNotNull(List *names, bool notNull)
 	 * Okay to update pg_type row.  We can scribble on typTup because it's a
 	 * copy.
 	 */
-	typTup->typnotnull = notNull;
+	HeapTupleUpdateField(pg_type, typnotnull, notNull, typTup, updated);
 
-	CatalogTupleUpdate(typrel, &tup->t_self, tup);
+	CatalogTupleUpdate(typrel, &tup->t_self, tup, updated, NULL);
 
 	InvokeObjectPostAlterHook(TypeRelationId, domainoid, 0);
 
@@ -2817,6 +2811,7 @@ AlterDomainNotNull(List *names, bool notNull)
 	/* Clean up */
 	heap_freetuple(tup);
 	table_close(typrel, RowExclusiveLock);
+	bms_free(updated);
 
 	return address;
 }
@@ -2842,6 +2837,7 @@ AlterDomainDropConstraint(List *names, const char *constrName,
 	HeapTuple	contup;
 	bool		found = false;
 	ObjectAddress address;
+	Bitmapset  *updated = NULL;
 
 	/* Make a TypeName so we can use standard type lookup machinery */
 	typename = makeTypeNameFromNameList(names);
@@ -2885,8 +2881,8 @@ AlterDomainDropConstraint(List *names, const char *constrName,
 
 		if (construct->contype == CONSTRAINT_NOTNULL)
 		{
-			((Form_pg_type) GETSTRUCT(tup))->typnotnull = false;
-			CatalogTupleUpdate(rel, &tup->t_self, tup);
+			HeapTupleUpdateField(pg_type, typnotnull, false, (Form_pg_type) GETSTRUCT(tup), updated);
+			CatalogTupleUpdate(rel, &tup->t_self, tup, updated, NULL);
 		}
 
 		conobj.classId = ConstraintRelationId;
@@ -2925,6 +2921,7 @@ AlterDomainDropConstraint(List *names, const char *constrName,
 
 	/* Clean up */
 	table_close(rel, RowExclusiveLock);
+	bms_free(updated);
 
 	return address;
 }
@@ -2946,6 +2943,7 @@ AlterDomainAddConstraint(List *names, Node *newConstraint,
 	Constraint *constr;
 	char	   *ccbin;
 	ObjectAddress address = InvalidObjectAddress;
+	Bitmapset  *updated = NULL;
 
 	/* Make a TypeName so we can use standard type lookup machinery */
 	typename = makeTypeNameFromNameList(names);
@@ -3014,14 +3012,15 @@ AlterDomainAddConstraint(List *names, Node *newConstraint,
 		if (!constr->skip_validation)
 			validateDomainNotNullConstraint(domainoid);
 
-		typTup->typnotnull = true;
-		CatalogTupleUpdate(typrel, &tup->t_self, tup);
+		HeapTupleUpdateField(pg_type, typnotnull, true, typTup, updated);
+		CatalogTupleUpdate(typrel, &tup->t_self, tup, updated, NULL);
 	}
 
 	ObjectAddressSet(address, TypeRelationId, domainoid);
 
 	/* Clean up */
 	table_close(typrel, RowExclusiveLock);
+	bms_free(updated);
 
 	return address;
 }
@@ -3048,6 +3047,7 @@ AlterDomainValidateConstraint(List *names, const char *constrName)
 	HeapTuple	copyTuple;
 	ScanKeyData skey[3];
 	ObjectAddress address;
+	Bitmapset  *updated = NULL;
 
 	/* Make a TypeName so we can use standard type lookup machinery */
 	typename = makeTypeNameFromNameList(names);
@@ -3113,8 +3113,8 @@ AlterDomainValidateConstraint(List *names, const char *constrName)
 	 */
 	copyTuple = heap_copytuple(tuple);
 	copy_con = (Form_pg_constraint) GETSTRUCT(copyTuple);
-	copy_con->convalidated = true;
-	CatalogTupleUpdate(conrel, &copyTuple->t_self, copyTuple);
+	HeapTupleUpdateField(pg_constraint, convalidated, true, copy_con, updated);
+	CatalogTupleUpdate(conrel, &copyTuple->t_self, copyTuple, updated, NULL);
 
 	InvokeObjectPostAlterHook(ConstraintRelationId, con->oid, 0);
 
@@ -3128,6 +3128,7 @@ AlterDomainValidateConstraint(List *names, const char *constrName)
 	table_close(conrel, RowExclusiveLock);
 
 	ReleaseSysCache(tup);
+	bms_free(updated);
 
 	return address;
 }
@@ -4002,9 +4003,9 @@ AlterTypeOwnerInternal(Oid typeOid, Oid newOwnerId)
 	Relation	rel;
 	HeapTuple	tup;
 	Form_pg_type typTup;
-	Datum		repl_val[Natts_pg_type];
-	bool		repl_null[Natts_pg_type];
-	bool		repl_repl[Natts_pg_type];
+	Datum		values[Natts_pg_type] = {0};
+	bool		nulls[Natts_pg_type] = {false};
+	Bitmapset  *updated = NULL;
 	Acl		   *newAcl;
 	Datum		aclDatum;
 	bool		isNull;
@@ -4016,11 +4017,7 @@ AlterTypeOwnerInternal(Oid typeOid, Oid newOwnerId)
 		elog(ERROR, "cache lookup failed for type %u", typeOid);
 	typTup = (Form_pg_type) GETSTRUCT(tup);
 
-	memset(repl_null, false, sizeof(repl_null));
-	memset(repl_repl, false, sizeof(repl_repl));
-
-	repl_repl[Anum_pg_type_typowner - 1] = true;
-	repl_val[Anum_pg_type_typowner - 1] = ObjectIdGetDatum(newOwnerId);
+	HeapTupleUpdateValue(pg_type, typowner, ObjectIdGetDatum(newOwnerId), values, nulls, updated);
 
 	aclDatum = heap_getattr(tup,
 							Anum_pg_type_typacl,
@@ -4031,14 +4028,12 @@ AlterTypeOwnerInternal(Oid typeOid, Oid newOwnerId)
 	{
 		newAcl = aclnewowner(DatumGetAclP(aclDatum),
 							 typTup->typowner, newOwnerId);
-		repl_repl[Anum_pg_type_typacl - 1] = true;
-		repl_val[Anum_pg_type_typacl - 1] = PointerGetDatum(newAcl);
+		HeapTupleUpdateValue(pg_type, typacl, PointerGetDatum(newAcl), values, nulls, updated);
 	}
 
-	tup = heap_modify_tuple(tup, RelationGetDescr(rel), repl_val, repl_null,
-							repl_repl);
+	tup = heap_update_tuple(tup, RelationGetDescr(rel), values, nulls, updated);
 
-	CatalogTupleUpdate(rel, &tup->t_self, tup);
+	CatalogTupleUpdate(rel, &tup->t_self, tup, updated, NULL);
 
 	/* If it has an array type, update that too */
 	if (OidIsValid(typTup->typarray))
@@ -4059,6 +4054,7 @@ AlterTypeOwnerInternal(Oid typeOid, Oid newOwnerId)
 
 	/* Clean up */
 	table_close(rel, RowExclusiveLock);
+	bms_free(updated);
 }
 
 /*
@@ -4179,6 +4175,7 @@ AlterTypeNamespaceInternal(Oid typeOid, Oid nspOid,
 	Oid			arrayOid;
 	bool		isCompositeType;
 	ObjectAddress thisobj;
+	Bitmapset  *updated = NULL;
 
 	/*
 	 * Make sure we haven't moved this object previously.
@@ -4244,9 +4241,9 @@ AlterTypeNamespaceInternal(Oid typeOid, Oid nspOid,
 		/* OK, modify the pg_type row */
 
 		/* tup is a copy, so we can scribble directly on it */
-		typform->typnamespace = nspOid;
+		HeapTupleUpdateField(pg_type, typnamespace, nspOid, typform, updated);
 
-		CatalogTupleUpdate(rel, &tup->t_self, tup);
+		CatalogTupleUpdate(rel, &tup->t_self, tup, updated, NULL);
 	}
 
 	/*
@@ -4310,6 +4307,7 @@ AlterTypeNamespaceInternal(Oid typeOid, Oid nspOid,
 								   true,	/* errorOnTableType */
 								   objsMoved);
 
+	bms_free(updated);
 	return oldNspOid;
 }
 
@@ -4577,9 +4575,9 @@ AlterTypeRecurse(Oid typeOid, bool isImplicitArray,
 				 HeapTuple tup, Relation catalog,
 				 AlterTypeRecurseParams *atparams)
 {
-	Datum		values[Natts_pg_type];
-	bool		nulls[Natts_pg_type];
-	bool		replaces[Natts_pg_type];
+	Datum		values[Natts_pg_type] = {0};
+	bool		nulls[Natts_pg_type] = {false};
+	Bitmapset  *updated = NULL;
 	HeapTuple	newtup;
 	SysScanDesc scan;
 	ScanKeyData key[1];
@@ -4589,50 +4587,25 @@ AlterTypeRecurse(Oid typeOid, bool isImplicitArray,
 	check_stack_depth();
 
 	/* Update the current type's tuple */
-	memset(values, 0, sizeof(values));
-	memset(nulls, 0, sizeof(nulls));
-	memset(replaces, 0, sizeof(replaces));
-
 	if (atparams->updateStorage)
-	{
-		replaces[Anum_pg_type_typstorage - 1] = true;
-		values[Anum_pg_type_typstorage - 1] = CharGetDatum(atparams->storage);
-	}
+		HeapTupleUpdateValue(pg_type, typstorage, CharGetDatum(atparams->storage), values, nulls, updated);
 	if (atparams->updateReceive)
-	{
-		replaces[Anum_pg_type_typreceive - 1] = true;
-		values[Anum_pg_type_typreceive - 1] = ObjectIdGetDatum(atparams->receiveOid);
-	}
+		HeapTupleUpdateValue(pg_type, typreceive, ObjectIdGetDatum(atparams->receiveOid), values, nulls, updated);
 	if (atparams->updateSend)
-	{
-		replaces[Anum_pg_type_typsend - 1] = true;
-		values[Anum_pg_type_typsend - 1] = ObjectIdGetDatum(atparams->sendOid);
-	}
+		HeapTupleUpdateValue(pg_type, typsend, ObjectIdGetDatum(atparams->sendOid), values, nulls, updated);
 	if (atparams->updateTypmodin)
-	{
-		replaces[Anum_pg_type_typmodin - 1] = true;
-		values[Anum_pg_type_typmodin - 1] = ObjectIdGetDatum(atparams->typmodinOid);
-	}
+		HeapTupleUpdateValue(pg_type, typmodin, ObjectIdGetDatum(atparams->typmodinOid), values, nulls, updated);
 	if (atparams->updateTypmodout)
-	{
-		replaces[Anum_pg_type_typmodout - 1] = true;
-		values[Anum_pg_type_typmodout - 1] = ObjectIdGetDatum(atparams->typmodoutOid);
-	}
+		HeapTupleUpdateValue(pg_type, typmodout, ObjectIdGetDatum(atparams->typmodoutOid), values, nulls, updated);
 	if (atparams->updateAnalyze)
-	{
-		replaces[Anum_pg_type_typanalyze - 1] = true;
-		values[Anum_pg_type_typanalyze - 1] = ObjectIdGetDatum(atparams->analyzeOid);
-	}
+		HeapTupleUpdateValue(pg_type, typanalyze, ObjectIdGetDatum(atparams->analyzeOid), values, nulls, updated);
 	if (atparams->updateSubscript)
-	{
-		replaces[Anum_pg_type_typsubscript - 1] = true;
-		values[Anum_pg_type_typsubscript - 1] = ObjectIdGetDatum(atparams->subscriptOid);
-	}
+		HeapTupleUpdateValue(pg_type, typsubscript, ObjectIdGetDatum(atparams->subscriptOid), values, nulls, updated);
 
-	newtup = heap_modify_tuple(tup, RelationGetDescr(catalog),
-							   values, nulls, replaces);
+	newtup = heap_update_tuple(tup, RelationGetDescr(catalog),
+							   values, nulls, updated);
 
-	CatalogTupleUpdate(catalog, &newtup->t_self, newtup);
+	CatalogTupleUpdate(catalog, &newtup->t_self, newtup, updated, NULL);
 
 	/* Rebuild dependencies for this type */
 	GenerateTypeDependencies(newtup,
@@ -4717,4 +4690,5 @@ AlterTypeRecurse(Oid typeOid, bool isImplicitArray,
 	}
 
 	systable_endscan(scan);
+	bms_free(updated);
 }
diff --git a/src/backend/commands/user.c b/src/backend/commands/user.c
index 8fb9ea25db0..8609703bc63 100644
--- a/src/backend/commands/user.c
+++ b/src/backend/commands/user.c
@@ -135,8 +135,8 @@ CreateRole(ParseState *pstate, CreateRoleStmt *stmt)
 	Relation	pg_authid_rel;
 	TupleDesc	pg_authid_dsc;
 	HeapTuple	tuple;
-	Datum		new_record[Natts_pg_authid] = {0};
-	bool		new_record_nulls[Natts_pg_authid] = {0};
+	Datum		values[Natts_pg_authid] = {0};
+	bool		nulls[Natts_pg_authid] = {false};
 	Oid			currentUserId = GetUserId();
 	Oid			roleid;
 	ListCell   *item;
@@ -406,15 +406,14 @@ CreateRole(ParseState *pstate, CreateRoleStmt *stmt)
 	/*
 	 * Build a tuple to insert
 	 */
-	new_record[Anum_pg_authid_rolname - 1] =
-		DirectFunctionCall1(namein, CStringGetDatum(stmt->role));
-	new_record[Anum_pg_authid_rolsuper - 1] = BoolGetDatum(issuper);
-	new_record[Anum_pg_authid_rolinherit - 1] = BoolGetDatum(inherit);
-	new_record[Anum_pg_authid_rolcreaterole - 1] = BoolGetDatum(createrole);
-	new_record[Anum_pg_authid_rolcreatedb - 1] = BoolGetDatum(createdb);
-	new_record[Anum_pg_authid_rolcanlogin - 1] = BoolGetDatum(canlogin);
-	new_record[Anum_pg_authid_rolreplication - 1] = BoolGetDatum(isreplication);
-	new_record[Anum_pg_authid_rolconnlimit - 1] = Int32GetDatum(connlimit);
+	HeapTupleSetValue(pg_authid, rolname, DirectFunctionCall1(namein, CStringGetDatum(stmt->role)), values);
+	HeapTupleSetValue(pg_authid, rolsuper, BoolGetDatum(issuper), values);
+	HeapTupleSetValue(pg_authid, rolinherit, BoolGetDatum(inherit), values);
+	HeapTupleSetValue(pg_authid, rolcreaterole, BoolGetDatum(createrole), values);
+	HeapTupleSetValue(pg_authid, rolcreatedb, BoolGetDatum(createdb), values);
+	HeapTupleSetValue(pg_authid, rolcanlogin, BoolGetDatum(canlogin), values);
+	HeapTupleSetValue(pg_authid, rolreplication, BoolGetDatum(isreplication), values);
+	HeapTupleSetValue(pg_authid, rolconnlimit, Int32GetDatum(connlimit), values);
 
 	if (password)
 	{
@@ -438,24 +437,24 @@ CreateRole(ParseState *pstate, CreateRoleStmt *stmt)
 		{
 			ereport(NOTICE,
 					(errmsg("empty string is not a valid password, clearing password")));
-			new_record_nulls[Anum_pg_authid_rolpassword - 1] = true;
+			HeapTupleSetValueNull(pg_authid, rolpassword, values, nulls);
 		}
 		else
 		{
 			/* Encrypt the password to the requested format. */
 			shadow_pass = encrypt_password(Password_encryption, stmt->role,
 										   password);
-			new_record[Anum_pg_authid_rolpassword - 1] =
-				CStringGetTextDatum(shadow_pass);
+			HeapTupleSetValue(pg_authid, rolpassword, CStringGetTextDatum(shadow_pass), values);
 		}
 	}
 	else
-		new_record_nulls[Anum_pg_authid_rolpassword - 1] = true;
+		HeapTupleSetValueNull(pg_authid, rolpassword, values, nulls);
 
-	new_record[Anum_pg_authid_rolvaliduntil - 1] = validUntil_datum;
-	new_record_nulls[Anum_pg_authid_rolvaliduntil - 1] = validUntil_null;
+	HeapTupleSetValue(pg_authid, rolvaliduntil, validUntil_datum, values);
+	if (validUntil_null)
+		HeapTupleSetValueNull(pg_authid, rolvaliduntil, values, nulls);
 
-	new_record[Anum_pg_authid_rolbypassrls - 1] = BoolGetDatum(bypassrls);
+	HeapTupleSetValue(pg_authid, rolbypassrls, BoolGetDatum(bypassrls), values);
 
 	/*
 	 * pg_largeobject_metadata contains pg_authid.oid's, so we use the
@@ -477,14 +476,14 @@ CreateRole(ParseState *pstate, CreateRoleStmt *stmt)
 									Anum_pg_authid_oid);
 	}
 
-	new_record[Anum_pg_authid_oid - 1] = ObjectIdGetDatum(roleid);
+	HeapTupleSetValue(pg_authid, oid, ObjectIdGetDatum(roleid), values);
 
-	tuple = heap_form_tuple(pg_authid_dsc, new_record, new_record_nulls);
+	tuple = heap_form_tuple(pg_authid_dsc, values, nulls);
 
 	/*
 	 * Insert new record in the pg_authid table
 	 */
-	CatalogTupleInsert(pg_authid_rel, tuple);
+	CatalogTupleInsert(pg_authid_rel, tuple, NULL);
 
 	/*
 	 * Advance command counter so we can see new record; else tests in
@@ -619,9 +618,9 @@ CreateRole(ParseState *pstate, CreateRoleStmt *stmt)
 Oid
 AlterRole(ParseState *pstate, AlterRoleStmt *stmt)
 {
-	Datum		new_record[Natts_pg_authid] = {0};
-	bool		new_record_nulls[Natts_pg_authid] = {0};
-	bool		new_record_repl[Natts_pg_authid] = {0};
+	Datum		values[Natts_pg_authid] = {0};
+	bool		nulls[Natts_pg_authid] = {false};
+	Bitmapset  *updated = NULL;
 	Relation	pg_authid_rel;
 	TupleDesc	pg_authid_dsc;
 	HeapTuple	tuple,
@@ -871,45 +870,26 @@ AlterRole(ParseState *pstate, AlterRoleStmt *stmt)
 					 errdetail("The bootstrap superuser must have the %s attribute.",
 							   "SUPERUSER")));
 
-		new_record[Anum_pg_authid_rolsuper - 1] = BoolGetDatum(should_be_super);
-		new_record_repl[Anum_pg_authid_rolsuper - 1] = true;
+		HeapTupleUpdateValue(pg_authid, rolsuper, BoolGetDatum(should_be_super), values, nulls, updated);
 	}
 
 	if (dinherit)
-	{
-		new_record[Anum_pg_authid_rolinherit - 1] = BoolGetDatum(boolVal(dinherit->arg));
-		new_record_repl[Anum_pg_authid_rolinherit - 1] = true;
-	}
+		HeapTupleUpdateValue(pg_authid, rolinherit, BoolGetDatum(boolVal(dinherit->arg)), values, nulls, updated);
 
 	if (dcreaterole)
-	{
-		new_record[Anum_pg_authid_rolcreaterole - 1] = BoolGetDatum(boolVal(dcreaterole->arg));
-		new_record_repl[Anum_pg_authid_rolcreaterole - 1] = true;
-	}
+		HeapTupleUpdateValue(pg_authid, rolcreaterole, BoolGetDatum(boolVal(dcreaterole->arg)), values, nulls, updated);
 
 	if (dcreatedb)
-	{
-		new_record[Anum_pg_authid_rolcreatedb - 1] = BoolGetDatum(boolVal(dcreatedb->arg));
-		new_record_repl[Anum_pg_authid_rolcreatedb - 1] = true;
-	}
+		HeapTupleUpdateValue(pg_authid, rolcreatedb, BoolGetDatum(boolVal(dcreatedb->arg)), values, nulls, updated);
 
 	if (dcanlogin)
-	{
-		new_record[Anum_pg_authid_rolcanlogin - 1] = BoolGetDatum(boolVal(dcanlogin->arg));
-		new_record_repl[Anum_pg_authid_rolcanlogin - 1] = true;
-	}
+		HeapTupleUpdateValue(pg_authid, rolcanlogin, BoolGetDatum(boolVal(dcanlogin->arg)), values, nulls, updated);
 
 	if (disreplication)
-	{
-		new_record[Anum_pg_authid_rolreplication - 1] = BoolGetDatum(boolVal(disreplication->arg));
-		new_record_repl[Anum_pg_authid_rolreplication - 1] = true;
-	}
+		HeapTupleUpdateValue(pg_authid, rolreplication, BoolGetDatum(boolVal(disreplication->arg)), values, nulls, updated);
 
 	if (dconnlimit)
-	{
-		new_record[Anum_pg_authid_rolconnlimit - 1] = Int32GetDatum(connlimit);
-		new_record_repl[Anum_pg_authid_rolconnlimit - 1] = true;
-	}
+		HeapTupleUpdateValue(pg_authid, rolconnlimit, Int32GetDatum(connlimit), values, nulls, updated);
 
 	/* password */
 	if (password)
@@ -923,40 +903,33 @@ AlterRole(ParseState *pstate, AlterRoleStmt *stmt)
 		{
 			ereport(NOTICE,
 					(errmsg("empty string is not a valid password, clearing password")));
-			new_record_nulls[Anum_pg_authid_rolpassword - 1] = true;
+			HeapTupleSetValueNull(pg_authid, rolpassword, values, nulls);
 		}
 		else
 		{
 			/* Encrypt the password to the requested format. */
 			shadow_pass = encrypt_password(Password_encryption, rolename,
 										   password);
-			new_record[Anum_pg_authid_rolpassword - 1] =
-				CStringGetTextDatum(shadow_pass);
+			HeapTupleUpdateValue(pg_authid, rolpassword, CStringGetTextDatum(shadow_pass), values, nulls, updated);
 		}
-		new_record_repl[Anum_pg_authid_rolpassword - 1] = true;
 	}
 
 	/* unset password */
 	if (dpassword && dpassword->arg == NULL)
-	{
-		new_record_repl[Anum_pg_authid_rolpassword - 1] = true;
-		new_record_nulls[Anum_pg_authid_rolpassword - 1] = true;
-	}
+		HeapTupleUpdateValueNull(pg_authid, rolpassword, values, nulls, updated);
 
 	/* valid until */
-	new_record[Anum_pg_authid_rolvaliduntil - 1] = validUntil_datum;
-	new_record_nulls[Anum_pg_authid_rolvaliduntil - 1] = validUntil_null;
-	new_record_repl[Anum_pg_authid_rolvaliduntil - 1] = true;
+	HeapTupleUpdateValue(pg_authid, rolvaliduntil, validUntil_datum, values, nulls, updated);
+	if (validUntil_null)
+		HeapTupleUpdateValueNull(pg_authid, rolvaliduntil, values, nulls, updated);
 
 	if (dbypassRLS)
-	{
-		new_record[Anum_pg_authid_rolbypassrls - 1] = BoolGetDatum(boolVal(dbypassRLS->arg));
-		new_record_repl[Anum_pg_authid_rolbypassrls - 1] = true;
-	}
+		HeapTupleUpdateValue(pg_authid, rolbypassrls, BoolGetDatum(boolVal(dbypassRLS->arg)), values, nulls, updated);
 
-	new_tuple = heap_modify_tuple(tuple, pg_authid_dsc, new_record,
-								  new_record_nulls, new_record_repl);
-	CatalogTupleUpdate(pg_authid_rel, &tuple->t_self, new_tuple);
+	new_tuple = heap_update_tuple(tuple, pg_authid_dsc, values,
+								  nulls, updated);
+	CatalogTupleUpdate(pg_authid_rel, &tuple->t_self, new_tuple, updated, NULL);
+	bms_free(updated);
 
 	InvokeObjectPostAlterHook(AuthIdRelationId, roleid, 0);
 
@@ -1340,10 +1313,9 @@ RenameRole(const char *oldname, const char *newname)
 	Relation	rel;
 	Datum		datum;
 	bool		isnull;
-	Datum		repl_val[Natts_pg_authid];
-	bool		repl_null[Natts_pg_authid];
-	bool		repl_repl[Natts_pg_authid];
-	int			i;
+	Datum		values[Natts_pg_authid] = {0};
+	bool		nulls[Natts_pg_authid] = {false};
+	Bitmapset  *updated = NULL;
 	Oid			roleid;
 	ObjectAddress address;
 	Form_pg_authid authform;
@@ -1434,29 +1406,22 @@ RenameRole(const char *oldname, const char *newname)
 							   "CREATEROLE", "ADMIN", NameStr(authform->rolname))));
 	}
 
-	/* OK, construct the modified tuple */
-	for (i = 0; i < Natts_pg_authid; i++)
-		repl_repl[i] = false;
-
-	repl_repl[Anum_pg_authid_rolname - 1] = true;
-	repl_val[Anum_pg_authid_rolname - 1] = DirectFunctionCall1(namein,
-															   CStringGetDatum(newname));
-	repl_null[Anum_pg_authid_rolname - 1] = false;
+	HeapTupleUpdateValue(pg_authid, rolname, DirectFunctionCall1(namein, CStringGetDatum(newname)), values, nulls, updated);
 
 	datum = heap_getattr(oldtuple, Anum_pg_authid_rolpassword, dsc, &isnull);
 
 	if (!isnull && get_password_type(TextDatumGetCString(datum)) == PASSWORD_TYPE_MD5)
 	{
 		/* MD5 uses the username as salt, so just clear it on a rename */
-		repl_repl[Anum_pg_authid_rolpassword - 1] = true;
-		repl_null[Anum_pg_authid_rolpassword - 1] = true;
+		HeapTupleUpdateValueNull(pg_authid, rolpassword, values, nulls, updated);
 
 		ereport(NOTICE,
 				(errmsg("MD5 password cleared because of role rename")));
 	}
 
-	newtuple = heap_modify_tuple(oldtuple, dsc, repl_val, repl_null, repl_repl);
-	CatalogTupleUpdate(rel, &oldtuple->t_self, newtuple);
+	newtuple = heap_update_tuple(oldtuple, dsc, values, nulls, updated);
+	CatalogTupleUpdate(rel, &oldtuple->t_self, newtuple, updated, NULL);
+	bms_free(updated);
 
 	InvokeObjectPostAlterHook(AuthIdRelationId, roleid, 0);
 
@@ -1824,17 +1789,14 @@ AddRoleMems(Oid currentUserId, const char *rolename, Oid roleid,
 		Oid			memberid = lfirst_oid(iditem);
 		HeapTuple	authmem_tuple;
 		HeapTuple	tuple;
-		Datum		new_record[Natts_pg_auth_members] = {0};
-		bool		new_record_nulls[Natts_pg_auth_members] = {0};
-		bool		new_record_repl[Natts_pg_auth_members] = {0};
+		Datum		values[Natts_pg_auth_members] = {0};
+		bool		nulls[Natts_pg_auth_members] = {false};
+		Bitmapset  *updated = NULL;
 
 		/* Common initialization for possible insert or update */
-		new_record[Anum_pg_auth_members_roleid - 1] =
-			ObjectIdGetDatum(roleid);
-		new_record[Anum_pg_auth_members_member - 1] =
-			ObjectIdGetDatum(memberid);
-		new_record[Anum_pg_auth_members_grantor - 1] =
-			ObjectIdGetDatum(grantorId);
+		HeapTupleUpdateValue(pg_auth_members, roleid, ObjectIdGetDatum(roleid), values, nulls, updated);
+		HeapTupleUpdateValue(pg_auth_members, member, ObjectIdGetDatum(memberid), values, nulls, updated);
+		HeapTupleUpdateValue(pg_auth_members, grantor, ObjectIdGetDatum(grantorId), values, nulls, updated);
 
 		/* Find any existing tuple */
 		authmem_tuple = SearchSysCache3(AUTHMEMROLEMEM,
@@ -1858,30 +1820,21 @@ AddRoleMems(Oid currentUserId, const char *rolename, Oid roleid,
 			if ((popt->specified & GRANT_ROLE_SPECIFIED_ADMIN) != 0
 				&& authmem_form->admin_option != popt->admin)
 			{
-				new_record[Anum_pg_auth_members_admin_option - 1] =
-					BoolGetDatum(popt->admin);
-				new_record_repl[Anum_pg_auth_members_admin_option - 1] =
-					true;
+				HeapTupleUpdateValue(pg_auth_members, admin_option, BoolGetDatum(popt->admin), values, nulls, updated);
 				at_least_one_change = true;
 			}
 
 			if ((popt->specified & GRANT_ROLE_SPECIFIED_INHERIT) != 0
 				&& authmem_form->inherit_option != popt->inherit)
 			{
-				new_record[Anum_pg_auth_members_inherit_option - 1] =
-					BoolGetDatum(popt->inherit);
-				new_record_repl[Anum_pg_auth_members_inherit_option - 1] =
-					true;
+				HeapTupleUpdateValue(pg_auth_members, inherit_option, BoolGetDatum(popt->inherit), values, nulls, updated);
 				at_least_one_change = true;
 			}
 
 			if ((popt->specified & GRANT_ROLE_SPECIFIED_SET) != 0
 				&& authmem_form->set_option != popt->set)
 			{
-				new_record[Anum_pg_auth_members_set_option - 1] =
-					BoolGetDatum(popt->set);
-				new_record_repl[Anum_pg_auth_members_set_option - 1] =
-					true;
+				HeapTupleUpdateValue(pg_auth_members, set_option, BoolGetDatum(popt->set), values, nulls, updated);
 				at_least_one_change = true;
 			}
 
@@ -1895,10 +1848,8 @@ AddRoleMems(Oid currentUserId, const char *rolename, Oid roleid,
 				continue;
 			}
 
-			tuple = heap_modify_tuple(authmem_tuple, pg_authmem_dsc,
-									  new_record,
-									  new_record_nulls, new_record_repl);
-			CatalogTupleUpdate(pg_authmem_rel, &tuple->t_self, tuple);
+			tuple = heap_update_tuple(authmem_tuple, pg_authmem_dsc, values, nulls, updated);
+			CatalogTupleUpdate(pg_authmem_rel, &tuple->t_self, tuple, updated, NULL);
 
 			ReleaseSysCache(authmem_tuple);
 		}
@@ -1912,10 +1863,8 @@ AddRoleMems(Oid currentUserId, const char *rolename, Oid roleid,
 			 * Either they were specified, or the defaults as set by
 			 * InitGrantRoleOptions are correct.
 			 */
-			new_record[Anum_pg_auth_members_admin_option - 1] =
-				BoolGetDatum(popt->admin);
-			new_record[Anum_pg_auth_members_set_option - 1] =
-				BoolGetDatum(popt->set);
+			HeapTupleSetValue(pg_auth_members, admin_option, BoolGetDatum(popt->admin), values);
+			HeapTupleSetValue(pg_auth_members, set_option, BoolGetDatum(popt->set), values);
 
 			/*
 			 * If the user specified a value for the inherit option, use
@@ -1923,8 +1872,7 @@ AddRoleMems(Oid currentUserId, const char *rolename, Oid roleid,
 			 * on the role-level property.
 			 */
 			if ((popt->specified & GRANT_ROLE_SPECIFIED_INHERIT) != 0)
-				new_record[Anum_pg_auth_members_inherit_option - 1] =
-					BoolGetDatum(popt->inherit);
+				HeapTupleSetValue(pg_auth_members, inherit_option, BoolGetDatum(popt->inherit), values);
 			else
 			{
 				HeapTuple	mrtup;
@@ -1934,18 +1882,16 @@ AddRoleMems(Oid currentUserId, const char *rolename, Oid roleid,
 				if (!HeapTupleIsValid(mrtup))
 					elog(ERROR, "cache lookup failed for role %u", memberid);
 				mrform = (Form_pg_authid) GETSTRUCT(mrtup);
-				new_record[Anum_pg_auth_members_inherit_option - 1] =
-					BoolGetDatum(mrform->rolinherit);
+				HeapTupleSetValue(pg_auth_members, inherit_option, BoolGetDatum(mrform->rolinherit), values);
 				ReleaseSysCache(mrtup);
 			}
 
 			/* get an OID for the new row and insert it */
 			objectId = GetNewOidWithIndex(pg_authmem_rel, AuthMemOidIndexId,
 										  Anum_pg_auth_members_oid);
-			new_record[Anum_pg_auth_members_oid - 1] = ObjectIdGetDatum(objectId);
-			tuple = heap_form_tuple(pg_authmem_dsc,
-									new_record, new_record_nulls);
-			CatalogTupleInsert(pg_authmem_rel, tuple);
+			HeapTupleSetValue(pg_auth_members, oid, ObjectIdGetDatum(objectId), values);
+			tuple = heap_form_tuple(pg_authmem_dsc, values, nulls);
+			CatalogTupleInsert(pg_authmem_rel, tuple, NULL);
 
 			/* updateAclDependencies wants to pfree array inputs */
 			newmembers[0] = grantorId;
@@ -1955,6 +1901,8 @@ AddRoleMems(Oid currentUserId, const char *rolename, Oid roleid,
 								  1, newmembers);
 		}
 
+		bms_free(updated);
+
 		/* CCI after each change, in case there are duplicates in list */
 		CommandCounterIncrement();
 	}
@@ -1987,7 +1935,6 @@ DelRoleMems(Oid currentUserId, const char *rolename, Oid roleid,
 	ListCell   *iditem;
 	CatCList   *memlist;
 	RevokeRoleGrantAction *actions;
-	int			i;
 
 	Assert(list_length(memberSpecs) == list_length(memberIds));
 
@@ -2035,7 +1982,7 @@ DelRoleMems(Oid currentUserId, const char *rolename, Oid roleid,
 	 * left alone, deleted, or just have the admin_option flag cleared.
 	 * Perform the appropriate action in each case.
 	 */
-	for (i = 0; i < memlist->n_members; ++i)
+	for (int i = 0; i < memlist->n_members; ++i)
 	{
 		HeapTuple	authmem_tuple;
 		Form_pg_auth_members authmem_form;
@@ -2060,39 +2007,24 @@ DelRoleMems(Oid currentUserId, const char *rolename, Oid roleid,
 		{
 			/* Just turn off the specified option */
 			HeapTuple	tuple;
-			Datum		new_record[Natts_pg_auth_members] = {0};
-			bool		new_record_nulls[Natts_pg_auth_members] = {0};
-			bool		new_record_repl[Natts_pg_auth_members] = {0};
+			Datum		values[Natts_pg_auth_members] = {0};
+			bool		nulls[Natts_pg_auth_members] = {false};
+			Bitmapset  *updated = NULL;
 
 			/* Build a tuple to update with */
 			if (actions[i] == RRG_REMOVE_ADMIN_OPTION)
-			{
-				new_record[Anum_pg_auth_members_admin_option - 1] =
-					BoolGetDatum(false);
-				new_record_repl[Anum_pg_auth_members_admin_option - 1] =
-					true;
-			}
+				HeapTupleUpdateValue(pg_auth_members, admin_option, BoolGetDatum(false), values, nulls, updated);
 			else if (actions[i] == RRG_REMOVE_INHERIT_OPTION)
-			{
-				new_record[Anum_pg_auth_members_inherit_option - 1] =
-					BoolGetDatum(false);
-				new_record_repl[Anum_pg_auth_members_inherit_option - 1] =
-					true;
-			}
+				HeapTupleUpdateValue(pg_auth_members, inherit_option, BoolGetDatum(false), values, nulls, updated);
 			else if (actions[i] == RRG_REMOVE_SET_OPTION)
-			{
-				new_record[Anum_pg_auth_members_set_option - 1] =
-					BoolGetDatum(false);
-				new_record_repl[Anum_pg_auth_members_set_option - 1] =
-					true;
-			}
+				HeapTupleUpdateValue(pg_auth_members, set_option, BoolGetDatum(false), values, nulls, updated);
 			else
 				elog(ERROR, "unknown role revoke action");
 
-			tuple = heap_modify_tuple(authmem_tuple, pg_authmem_dsc,
-									  new_record,
-									  new_record_nulls, new_record_repl);
-			CatalogTupleUpdate(pg_authmem_rel, &tuple->t_self, tuple);
+			tuple = heap_update_tuple(authmem_tuple, pg_authmem_dsc,
+									  values, nulls, updated);
+			CatalogTupleUpdate(pg_authmem_rel, &tuple->t_self, tuple, updated, NULL);
+			bms_free(updated);
 		}
 	}
 
